<template>
  <ob-form
      class="form-add"
      :form-data="formData"
      :ok-text="'Сохранить'"
      cancel-text="Отменить"
      @submit="onSubmitHandler"
  >
    <div class="form-add__number row">
      <div class="col-xs-12">1. Выберите тип документа</div>
      <div class="col-xs-12">
        <ob-select
            :remote-opt="loadTypeDocuments"
            v-model="formData.docTypeUuid"
            placeholder="Выберите"
            label="Тип документа"
            class="filter-documentation__add-group-left-select"
            displayExp="name"
            valueExp="uuid"
            @input="selectedType"
            required
        />
      </div>
    </div>
    <div class="form-add__number row">
      <div class="col-xs-12">2. Загрузите скан документа <span class="form-add__number-require">*</span></div>
      <div class="col-xs-12">
        <ObUploader
            :multiple="true"
            @change="onChangeFiles($event)"
            :is-detail-emit="true"
            data-qa="uploader"
            required
        />
      </div>
    </div>
    <div class="form-add__number row">
      <div class="col-xs-12">3. Добавьте комментарий (необязательно)</div>
      <div class="col-xs-12">
        <ob-textarea
            label="Комментарий"
            placeholder="Если хотите, можете добавить комментарий к загружаемому документу"
            v-model="formData.comment"
        />
      </div>
    </div>
  </ob-form>
</template>

<script>
  import ObForm from 'common-components/src/obComponents/obForm';
  import ObSelect from 'common-components/src/obComponents/obSelect';
  import DOCUMENT_CLASS_MIXIN from '@/mixins/enum/document-class';
  import FormValidationMixin from "common-components/src/obComponents/obForm/FormValidationMixin";
  import ObUploader from 'common-components/src/obComponents/obUploader';
  import ObTextarea from 'common-components/src/obComponents/obTextarea';
  import api from "@/api";
  import {tokenData} from '@/utils/jwt';
  import {mapActions} from "vuex";

  export default {
    name: "formAdd",
    components: {
      ObForm,
      ObSelect,
      ObUploader,
      ObTextarea
    },
    mixins: [
      FormValidationMixin,
      DOCUMENT_CLASS_MIXIN,
    ],
    data() {
      return {
        formData: {
          docTypeUuid: '',
          files: [],
          comment: ''
        }
      }
    },
    methods: {
      ...mapActions({
        addNewDocument: 'documents/addNewDocument'
      }),
      async loadTypeDocuments() {
        try {
          const data = await api.documents.loadTypeDocuments();
          return data;
        } catch (e) {
          console.error('Ошибка загрущки списка типов документов:', e);
          this.$notification({
            type: "system_notification_error",
            message: "Ошибка загрузки данных"
          });
          return [];
        }
      },
      selectedType(type) {
        this.formData.docTypeUuid = type
      },
      async onChangeFiles(event) {
        const file = event.added[0];
        const form = new FormData();
        const jsonData = {
          filename: file.file.name,
          participant_uuid: tokenData.contractor_uuid,
          is_personal_info: false
        };
        form.append("jsonData", JSON.stringify(jsonData));
        form.append("file", file.file);
        const uuid_files = [];
        await api.documents.sendScanFiles(file.uuid, form).then(() => {
          event.files.forEach(key => uuid_files.push(key.uuid));
          this.$notification({
            type: 'system_notification_success',
            message: 'Скан добавлен'
          });
          this.formData.files = uuid_files;
        });
      },
      onSubmitHandler() {
        this.addNewDocument(this.formData).then(() => {
          this.$emit('closeModal');
          this.$notification({
            type: 'system_notification_success',
            message: 'Документ добавлен'
          });
          }
        )
      }
    }
  }
</script>

<style scoped lang="scss">
  .form-add {
    &__number {
      font-weight: bold;
      font-size: 16px;
      line-height: 20px;
      letter-spacing: 0.4px;
      color: $color-text-base;
      margin-top: 35px !important;
      & > .col-xs-12 {
        margin-bottom: 10px;
      }
      &-require {
        color: $color-error ;
      }
    }
  }
</style>
